# -*- coding: utf-8 -*-
"""
Created on Tue Nov 16 17:26:54 2021

@author: coenv
"""

#import packages

import math
 
#imput parameters
ink_name = "CV-GnP5-PU9"
D =  [0.160, 0.110] #Nozzle sizes available [mm]: 0.864, 0.686, 0.609, 0.564, 0.437, 0.335, 0.223, 0.160, 0.110, 0.060
Pulses_per_uL = 1305

for nozzle in D:

    #Choose which head you are using
    Head = 2                            #left to right, 1 through 5
    Head_number = "H"+str(Head)
    Target_head = "T1" + str(Head)
                
    #Generate the GCODE file
        
    #Create an empty GCODE file
        
    f = open(ink_name+" Three_factor_DoE_D"+str(nozzle)+".GCODE", "a")
        
    # Home all axes
        
    print("G28 Z0", file=f)
    print("G28 X0 Y0", file=f)
        
    #Choose starting Z position
    Z_start = " Z100"
        
    print("M660 "+Head_number+Z_start+" ; Define starting Z position", file=f)
        
    #define starting X and Y
        
    X_start = "X100 "
    Y_start = "Y50"
        
    print("M6 "+Target_head+" O2 "+X_start+Y_start+" ; Define starting X and Y position", file=f)
        
    #Choose printing temperature
    #T_h = "[temperature_head]"
    #print("M109 T12 S"+T_h)
        
    #Choose tempeature for bed
    #T_b = "[temperature_bed]"
    #print("M190 S"+T_b)
        
    #Set priming parameters
        
    Prim_speed_n = "S10000" #speed at which prime move should be executed (usually 10000)
    Prim_pulses_n = "E2000" #number of pulses on the feed to execute
    Prim_dwelltime_n = "P2000" #number of milliseconds to dwell relative to start of the move
        
    print("M722 "+Prim_speed_n+" "+Prim_pulses_n+" "+Prim_dwelltime_n+" "+Target_head+" ; Set priming parameters", file=f)
        
    #Set unpriming parameters
        
    unPrim_speed_n = "S10000" #speed at which unprime move should be executed (usually 10000)
    unPrim_pulses_n = "E2000" #number of pulses on the feed to execute
    unPrim_dwelltime_n = "P-2000" #number of milliseconds to dwell relative to start of the move (usually negative number!)
        
    print("M721 "+unPrim_speed_n+" "+unPrim_pulses_n+" "+unPrim_dwelltime_n+" "+Target_head+" ; Set unpriming parameters", file=f)
        
    #correct for circular nozzle
        
    Flow_W = round(math.sqrt(math.pi/4)*nozzle,3)
    Flow_Z = round(math.sqrt(math.pi/4)*nozzle,3)
        
        #Set flow rate
        
    Flow_P_n = "P"+str(Pulses_per_uL) #Number of pulses on the motor to dispense 1 uL of material
    Flow_S_n = "S"+str(1) #Direct flow multiplier
    Flow_W_n = "W"+ str(Flow_W) #Width of the cross section of the volume to fill
    Flow_Z_n = "Z"+ str(Flow_Z) #Height of the cross section of the volume to fill
        
    print("M221 "+Flow_P_n+" "+Flow_S_n+" "+Target_head+" "+Flow_Z_n+" "+Flow_W_n+" ; Set flow parameters", file=f)
            
    #Set units to milimeters
    print("G21", file=f)
        
    #Set coordinates: relative
    print("G91", file=f)
         
    #Set coordinates: absolute
    print("G90", file=f)
        
    #Use absolute distances for extrusion
    print("M82", file=f)
        
    #Unknown
    print("G92 E0", file=f)
        
    #Invoke starting X and Y
    print("T"+str((Head-1)), file=f)
        
    #START PRINTING
    print(";-----Start printing-----", file=f)
    
    print("M221 "+Target_head+" "+Flow_P_n, file=f) #set new pulses per uL
    print("G0 X0 Y0", file=f) #goes to starting point XY
    print("G0 Z0 "+Head_number, file=f) #goes to starting point Z
        
    print("M221 "+Target_head+" S0.XXX ;Edit this according to DoE run", file=f) #set flow rate multiplier S
    print("G1 Z0.XXX E1 FXXX ;Edit this according to DoE run", file=f) #Set standoff distance (Z) and printing speed (F)
    print("G1 X0 Y60 E1", file=f) #begin pre-printing
    print("G1 X2 Y60 E1", file=f)
    print("G1 X2 Y0 E1", file=f)
    print("G1 X4 Y0 E1", file=f) #end pre-printing
    
    print("G1 X4 Y5 E1", file=f) #begin structure 1/5
    print("G1 X9 Y5 E1", file=f)
    print("G1 X9 Y10 E1", file=f)
    print("G1 X4 Y10 E1", file=f)
    
    print("G1 X4 Y50 E1", file=f) #Conductivity track
    
    print("G1 X9 Y50 E1", file=f)
    print("G1 X9 Y55 E1", file=f)
    print("G1 X4 Y55 E1", file=f)
    print("G1 X4 Y60 E1", file=f)
    
    print("G1 X14 Y60 E1", file=f)
    print("G1 X14 Y40 E1", file=f)
    
    print("G1 X6 Y40 E1", file=f)
    print("G1 X6 Y39 E1", file=f) #1.0mm spacing
    print("G1 X14 Y39 E1", file=f)
    print("G1 X14 Y38 E1", file=f)
    
    print("G1 X6 Y38 E1", file=f)
    print("G1 X6 Y37.1 E1", file=f) #0.9mm spacing
    print("G1 X14 Y37.1 E1", file=f)
    print("G1 X14 Y36 E1", file=f)
    
    print("G1 X6 Y36 E1", file=f)
    print("G1 X6 Y35.2 E1", file=f) #0.8mm spacing
    print("G1 X14 Y35.2 E1", file=f)
    print("G1 X14 Y34 E1", file=f)
    
    print("G1 X6 Y34 E1", file=f)
    print("G1 X6 Y33.3 E1", file=f) #0.7mm spacing
    print("G1 X14 Y33.3 E1", file=f)
    print("G1 X14 Y32 E1", file=f)
    
    print("G1 X6 Y32 E1", file=f)
    print("G1 X6 Y31.4 E1", file=f) #0.6mm spacing
    print("G1 X14 Y31.4 E1", file=f)
    print("G1 X14 Y30 E1", file=f)
    
    print("G1 X6 Y30 E1", file=f)
    print("G1 X6 Y29.5 E1", file=f) #0.5mm spacing
    print("G1 X14 Y29.5 E1", file=f)
    print("G1 X14 Y28 E1", file=f)
    
    print("G1 X6 Y28 E1", file=f)
    print("G1 X6 Y27.6 E1", file=f) #0.4mm spacing
    print("G1 X14 Y27.6 E1", file=f)
    print("G1 X14 Y26 E1", file=f)
    
    print("G1 X6 Y26 E1", file=f)
    print("G1 X6 Y25.7 E1", file=f) #0.3mm spacing
    print("G1 X14 Y25.7 E1", file=f)
    print("G1 X14 Y24 E1", file=f)
    
    # print("G1 X6 Y24 E1", file=f)
    # print("G1 X6 Y23.8 E1", file=f) #0.2mm spacing
    # print("G1 X14 Y23.8 E1", file=f)
    # print("G1 X14 Y22 E1", file=f)
    
    # print("G1 X6 Y22 E1", file=f)
    # print("G1 X6 Y21.9 E1", file=f) #0.1mm spacing
    # print("G1 X14 Y21.9 E1", file=f)
    # print("G1 X14 Y20 E1", file=f)
    
    print("G1 X14 Y0 E1", file=f)
    
    print("G1 X16 Y0 E1", file=f) #end structure 1/5
    
    print("G1 X16 Y5 E1", file=f) #begin structure 2/5
    print("G1 X21 Y5 E1", file=f)
    print("G1 X21 Y10 E1", file=f)
    print("G1 X16 Y10 E1", file=f)
    
    print("G1 X16 Y50 E1", file=f) #Conductivity track
    
    print("G1 X21 Y50 E1", file=f)
    print("G1 X21 Y55 E1", file=f)
    print("G1 X16 Y55 E1", file=f)
    print("G1 X16 Y60 E1", file=f)
    
    print("G1 X26 Y60 E1", file=f)
    print("G1 X26 Y40 E1", file=f)
    
    print("G1 X18 Y40 E1", file=f)
    print("G1 X18 Y39 E1", file=f) #1.0mm spacing
    print("G1 X26 Y39 E1", file=f)
    print("G1 X26 Y38 E1", file=f)
    
    print("G1 X18 Y38 E1", file=f)
    print("G1 X18 Y37.1 E1", file=f) #0.9mm spacing
    print("G1 X26 Y37.1 E1", file=f)
    print("G1 X26 Y36 E1", file=f)
    
    print("G1 X18 Y36 E1", file=f)
    print("G1 X18 Y35.2 E1", file=f) #0.8mm spacing
    print("G1 X26 Y35.2 E1", file=f)
    print("G1 X26 Y34 E1", file=f)
    
    print("G1 X18 Y34 E1", file=f)
    print("G1 X18 Y33.3 E1", file=f) #0.7mm spacing
    print("G1 X26 Y33.3 E1", file=f)
    print("G1 X26 Y32 E1", file=f)
    
    print("G1 X18 Y32 E1", file=f)
    print("G1 X18 Y31.4 E1", file=f) #0.6mm spacing
    print("G1 X26 Y31.4 E1", file=f)
    print("G1 X26 Y30 E1", file=f)
    
    print("G1 X18 Y30 E1", file=f)
    print("G1 X18 Y29.5 E1", file=f) #0.5mm spacing
    print("G1 X26 Y29.5 E1", file=f)
    print("G1 X26 Y28 E1", file=f)
    
    print("G1 X18 Y28 E1", file=f)
    print("G1 X18 Y27.6 E1", file=f) #0.4mm spacing
    print("G1 X26 Y27.6 E1", file=f)
    print("G1 X26 Y26 E1", file=f)
    
    print("G1 X18 Y26 E1", file=f)
    print("G1 X18 Y25.7 E1", file=f) #0.3mm spacing
    print("G1 X26 Y25.7 E1", file=f)
    print("G1 X26 Y24 E1", file=f)
    
    # print("G1 X18 Y24 E1", file=f)
    # print("G1 X18 Y23.8 E1", file=f) #0.2mm spacing
    # print("G1 X26 Y23.8 E1", file=f)
    # print("G1 X26 Y22 E1", file=f)
    
    # print("G1 X18 Y22 E1", file=f)
    # print("G1 X18 Y21.9 E1", file=f) #0.1mm spacing
    # print("G1 X26 Y21.9 E1", file=f)
    # print("G1 X26 Y20 E1", file=f)
    
    print("G1 X26 Y0 E1", file=f)
    
    print("G1 X28 Y0 E1", file=f) #end structure 2/5
    
    print("G1 X28 Y5 E1", file=f) #begin structure 3/5
    print("G1 X33 Y5 E1", file=f)
    print("G1 X33 Y10 E1", file=f)
    print("G1 X28 Y10 E1", file=f)
    
    print("G1 X28 Y50 E1", file=f) #Conductivity track
    
    print("G1 X33 Y50 E1", file=f)
    print("G1 X33 Y55 E1", file=f)
    print("G1 X28 Y55 E1", file=f)
    print("G1 X28 Y60 E1", file=f)
    
    print("G1 X38 Y60 E1", file=f)
    print("G1 X38 Y40 E1", file=f)
    
    print("G1 X30 Y40 E1", file=f)
    print("G1 X30 Y39 E1", file=f) #1.0mm spacing
    print("G1 X38 Y39 E1", file=f)
    print("G1 X38 Y38 E1", file=f)
    
    print("G1 X30 Y38 E1", file=f)
    print("G1 X30 Y37.1 E1", file=f) #0.9mm spacing
    print("G1 X38 Y37.1 E1", file=f)
    print("G1 X38 Y36 E1", file=f)
    
    print("G1 X30 Y36 E1", file=f)
    print("G1 X30 Y35.2 E1", file=f) #0.8mm spacing
    print("G1 X38 Y35.2 E1", file=f)
    print("G1 X38 Y34 E1", file=f)
    
    print("G1 X30 Y34 E1", file=f)
    print("G1 X30 Y33.3 E1", file=f) #0.7mm spacing
    print("G1 X38 Y33.3 E1", file=f)
    print("G1 X38 Y32 E1", file=f)
    
    print("G1 X30 Y32 E1", file=f)
    print("G1 X30 Y31.4 E1", file=f) #0.6mm spacing
    print("G1 X38 Y31.4 E1", file=f)
    print("G1 X38 Y30 E1", file=f)
    
    print("G1 X30 Y30 E1", file=f)
    print("G1 X30 Y29.5 E1", file=f) #0.5mm spacing
    print("G1 X38 Y29.5 E1", file=f)
    print("G1 X38 Y28 E1", file=f)
    
    print("G1 X30 Y28 E1", file=f)
    print("G1 X30 Y27.6 E1", file=f) #0.4mm spacing
    print("G1 X38 Y27.6 E1", file=f)
    print("G1 X38 Y26 E1", file=f)
    
    print("G1 X30 Y26 E1", file=f)
    print("G1 X30 Y25.7 E1", file=f) #0.3mm spacing
    print("G1 X38 Y25.7 E1", file=f)
    print("G1 X38 Y24 E1", file=f)
    
    # print("G1 X30 Y24 E1", file=f)
    # print("G1 X30 Y23.8 E1", file=f) #0.2mm spacing
    # print("G1 X38 Y23.8 E1", file=f)
    # print("G1 X38 Y22 E1", file=f)
    
    # print("G1 X30 Y22 E1", file=f)
    # print("G1 X30 Y21.9 E1", file=f) #0.1mm spacing
    # print("G1 X38 Y21.9 E1", file=f)
    # print("G1 X38 Y20 E1", file=f)
    
    print("G1 X38 Y0 E1", file=f)
    
    print("G1 X40 Y0 E1", file=f) #end structure 3/5
    
    print("G1 X40 Y5 E1", file=f) #begin structure 4/5
    print("G1 X45 Y5 E1", file=f)
    print("G1 X45 Y10 E1", file=f)
    print("G1 X40 Y10 E1", file=f)
    
    print("G1 X40 Y50 E1", file=f) #Conductivity track
    
    print("G1 X45 Y50 E1", file=f)
    print("G1 X45 Y55 E1", file=f)
    print("G1 X40 Y55 E1", file=f)
    print("G1 X40 Y60 E1", file=f)
    
    print("G1 X50 Y60 E1", file=f)
    print("G1 X50 Y40 E1", file=f)
    
    print("G1 X42 Y40 E1", file=f)
    print("G1 X42 Y39 E1", file=f) #1.0mm spacing
    print("G1 X50 Y39 E1", file=f)
    print("G1 X50 Y38 E1", file=f)
    
    print("G1 X42 Y38 E1", file=f)
    print("G1 X42 Y37.1 E1", file=f) #0.9mm spacing
    print("G1 X50 Y37.1 E1", file=f)
    print("G1 X50 Y36 E1", file=f)
    
    print("G1 X42 Y36 E1", file=f)
    print("G1 X42 Y35.2 E1", file=f) #0.8mm spacing
    print("G1 X50 Y35.2 E1", file=f)
    print("G1 X50 Y34 E1", file=f)
    
    print("G1 X42 Y34 E1", file=f)
    print("G1 X42 Y33.3 E1", file=f) #0.7mm spacing
    print("G1 X50 Y33.3 E1", file=f)
    print("G1 X50 Y32 E1", file=f)
    
    print("G1 X42 Y32 E1", file=f)
    print("G1 X42 Y31.4 E1", file=f) #0.6mm spacing
    print("G1 X50 Y31.4 E1", file=f)
    print("G1 X50 Y30 E1", file=f)
    
    print("G1 X42 Y30 E1", file=f)
    print("G1 X42 Y29.5 E1", file=f) #0.5mm spacing
    print("G1 X50 Y29.5 E1", file=f)
    print("G1 X50 Y28 E1", file=f)
    
    print("G1 X42 Y28 E1", file=f)
    print("G1 X42 Y27.6 E1", file=f) #0.4mm spacing
    print("G1 X50 Y27.6 E1", file=f)
    print("G1 X50 Y26 E1", file=f)
    
    print("G1 X42 Y26 E1", file=f)
    print("G1 X42 Y25.7 E1", file=f) #0.3mm spacing
    print("G1 X50 Y25.7 E1", file=f)
    print("G1 X50 Y24 E1", file=f)
    
    # print("G1 X42 Y24 E1", file=f)
    # print("G1 X42 Y23.8 E1", file=f) #0.2mm spacing
    # print("G1 X50 Y23.8 E1", file=f)
    # print("G1 X50 Y22 E1", file=f)
    
    # print("G1 X42 Y22 E1", file=f)
    # print("G1 X42 Y21.9 E1", file=f) #0.1mm spacing
    # print("G1 X50 Y21.9 E1", file=f)
    # print("G1 X50 Y20 E1", file=f)
    
    print("G1 X50 Y0 E1", file=f)
    
    print("G1 X52 Y0 E1", file=f) #end structure 4/5
    
    print("G1 X52 Y5 E1", file=f) #begin structure 5/5
    print("G1 X57 Y5 E1", file=f)
    print("G1 X57 Y10 E1", file=f)
    print("G1 X52 Y10 E1", file=f)
    
    print("G1 X52 Y50 E1", file=f) #Conductivity track
    
    print("G1 X57 Y50 E1", file=f)
    print("G1 X57 Y55 E1", file=f)
    print("G1 X52 Y55 E1", file=f)
    print("G1 X52 Y60 E1", file=f)
    
    print("G1 X62 Y60 E1", file=f)
    print("G1 X62 Y40 E1", file=f)
    
    print("G1 X54 Y40 E1", file=f)
    print("G1 X54 Y39 E1", file=f) #1.0mm spacing
    print("G1 X62 Y39 E1", file=f)
    print("G1 X62 Y38 E1", file=f)
    
    print("G1 X54 Y38 E1", file=f)
    print("G1 X54 Y37.1 E1", file=f) #0.9mm spacing
    print("G1 X62 Y37.1 E1", file=f)
    print("G1 X62 Y36 E1", file=f)
    
    print("G1 X54 Y36 E1", file=f)
    print("G1 X54 Y35.2 E1", file=f) #0.8mm spacing
    print("G1 X62 Y35.2 E1", file=f)
    print("G1 X62 Y34 E1", file=f)
    
    print("G1 X54 Y34 E1", file=f)
    print("G1 X54 Y33.3 E1", file=f) #0.7mm spacing
    print("G1 X62 Y33.3 E1", file=f)
    print("G1 X62 Y32 E1", file=f)
    
    print("G1 X54 Y32 E1", file=f)
    print("G1 X54 Y31.4 E1", file=f) #0.6mm spacing
    print("G1 X62 Y31.4 E1", file=f)
    print("G1 X62 Y30 E1", file=f)
    
    print("G1 X54 Y30 E1", file=f)
    print("G1 X54 Y29.5 E1", file=f) #0.5mm spacing
    print("G1 X62 Y29.5 E1", file=f)
    print("G1 X62 Y28 E1", file=f)
    
    print("G1 X54 Y28 E1", file=f)
    print("G1 X54 Y27.6 E1", file=f) #0.4mm spacing
    print("G1 X62 Y27.6 E1", file=f)
    print("G1 X62 Y26 E1", file=f)
    
    print("G1 X54 Y26 E1", file=f)
    print("G1 X54 Y25.7 E1", file=f) #0.3mm spacing
    print("G1 X62 Y25.7 E1", file=f)
    print("G1 X62 Y24 E1", file=f)
    
    # print("G1 X54 Y24 E1", file=f)
    # print("G1 X54 Y23.8 E1", file=f) #0.2mm spacing
    # print("G1 X62 Y23.8 E1", file=f)
    # print("G1 X62 Y22 E1", file=f)
    
    # print("G1 X54 Y22 E1", file=f)
    # print("G1 X54 Y21.9 E1", file=f) #0.1mm spacing
    # print("G1 X62 Y21.9 E1", file=f)
    # print("G1 X62 Y20 E1", file=f)
    
    print("G1 X62 Y0 E1", file=f)
    
    print("G1 X64 Y0 E1", file=f) #end structure 5/5
    
    
    print("G1 X74 Y0 E1", file=f) #Go to end position   
        
    #Home Z-axis
        
    print("G28 Z0", file=f)
        
    #Clear offsets
        
    print("G53", file=f)
        
    #End print job
        
    print("M30", file=f)
    f.close()
    
