# -*- coding: utf-8 -*-
"""
Hier even uitleg schrijven

@author: coenv
"""

#create GCODE using Python - Coen Vonk (SPC)

#Pick GCODE name

f = open("OptimizingflowCV_GNP5_PU8_859um.GCODE", "a")

#Enter ink parameters
Shear_th_index=0.393

#Enter printer parameters
Noz_diameter= 0.859 #in millimeters
Target_Shearrate = 100
Pulses_per_uL = 500

#Choose which head you are using
Head = 2                            #left to right, 1 through 5
Head_number = "H"+str(Head)
Target_head = "T1" + str(Head)

#=====Levels DoE=====

#Printing speed

F =round(((60*Shear_th_index*Target_Shearrate*Noz_diameter)/((3*Shear_th_index)+1)))

# Home all axes

print("G28 Z0", file=f)
print("G28 X0 Y0", file=f)

#Choose starting Z position
Z_start = " Z100"

print("M660 "+Head_number+Z_start+" ; Define starting Z position", file=f)

#define starting X and Y

X_start = "X100 "
Y_start = "Y50"

print("M6 "+Target_head+" O2 "+X_start+Y_start+" ; Define starting X and Y position", file=f)

#Choose printing temperature
#T_h = "[temperature_head]"
#print("M109 T12 S"+T_h)

#Choose tempeature for bed
#T_b = "[temperature_bed]"
#print("M190 S"+T_b)

#Set priming parameters

Prim_speed_n = "S10000" #speed at which prime move should be executed (usually 10000)
Prim_pulses_n = "E1000" #number of pulses on the feed to execute
Prim_dwelltime_n = "P2000" #number of milliseconds to dwell relative to start of the move

print("M722 "+Prim_speed_n+" "+Prim_pulses_n+" "+Prim_dwelltime_n+" "+Target_head+" ; Set priming parameters", file=f)

#Set unpriming parameters

unPrim_speed_n = "S10000" #speed at which unprime move should be executed (usually 10000)
unPrim_pulses_n = "E1000" #number of pulses on the feed to execute
unPrim_dwelltime_n = "P-2000" #number of milliseconds to dwell relative to start of the move (usually negative number!)

print("M721 "+unPrim_speed_n+" "+unPrim_pulses_n+" "+unPrim_dwelltime_n+" "+Target_head+" ; Set unpriming parameters", file=f)

#Set flow rate

Flow_P_n = "P"+str(Pulses_per_uL) #Number of pulses on the motor to dispense 1 uL of material
Flow_S_n = "S"+str(0.785) #Direct flow multiplier
Flow_W_n = "W"+ str(Noz_diameter) #Width of the cross section of the volume to fill
Flow_Z_n = "Z"+ str(Noz_diameter) #Height of the cross section of the volume to fill

print("M221 "+Flow_P_n+" "+Flow_S_n+" "+Target_head+" "+Flow_Z_n+" "+Flow_W_n+" ; Set flow parameters", file=f)

Flow = round((Pulses_per_uL*0.785*Noz_diameter*Noz_diameter*F)/60,2)

print("Flow: "+str(Flow)+" pulses per second")

#Set units to milimeters
print("G21", file=f)

#Set coordinates: relative
print("G91", file=f)
 
#Set coordinates: absolute
print("G90", file=f)

#Use absolute distances for extrusion
print("M82", file=f)

#Unknown
print("G92 E0", file=f)

#Invoke starting X and Y
print("T"+str((Head-1)), file=f)

#START PRINTING
print(";-----Start printing-----", file=f)

print("M221 "+Target_head+" "+Flow_P_n, file=f) #set new pulses per uL
print("G0 X0 Y0", file=f) #goes to starting point XY
print("G0 Z0 "+Head_number, file=f) #goes to starting point Z

print("G2 X0 Y0 I0 J5 E1 F"+str(F), file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)
print("G2 X0 Y0 I0 J5 E1", file=f)

#Home Z-axis

print("G28 Z0", file=f)

#Clear offsets

print("G53", file=f)

#End print job

print("M30", file=f)
f.close()